var panel = new Panel
var panelScreen = panel.screen
var freeEdges = {"bottom": true, "top": true, "left": true, "right": true}
var isHorizontal = false;
var isVertical = false;

for (i = 0; i < panelIds.length; ++i) {
    var tmpPanel = panelById(panelIds[i])
    if (tmpPanel.screen == panelScreen) {
        // Ignore the new panel
        if (tmpPanel.id != panel.id) {
            freeEdges[tmpPanel.location] = false;
        }
    }
}

if (freeEdges["bottom"] == true) {
    panel.location = "bottom";
} else if (freeEdges["top"] == true) {
    panel.location = "top";
} else if (freeEdges["left"] == true) {
    panel.location = "left";
} else if (freeEdges["right"] == true) {
    panel.location = "right";
} else {
    // There is no free edge, so leave the default value
    panel.location = "top";
}

if (panel.location == "top" || panel.location == "bottom") {
    // Horizontal
    isHorizontal = true;
    panel.height = gridUnit * 2
} else {
    // Vertical
    isVertical = true;
    panel.height = gridUnit * 3
}

panel.addWidget("org.kde.plasma.lock_logout")
//var activity = panel.addWidget("org.kde.plasma.showActivityManager")
//activity.writeConfig("ShowActivityNames", "false"),
var Spacer = panel.addWidget("org.kde.plasma.panelspacer")
Spacer.currentConfigGroup = ["Configuration","General"]
Spacer.writeConfig("expanding","false")

//Add widgets
var appMenu = panel.addWidget("org.kde.plasma.simplemenu")
appMenu.currentConfigGroup = ["Shortcuts"]
appMenu.writeConfig("global", "Alt+F1")
appMenu.currentConfigGroup = ["Configuration","General"]
appMenu.writeConfig("appNameFormat","1"),
appMenu.writeConfig("favoritesPortedToKAstats", "true"),
appMenu.writeConfig("favoriteApps", [
    'systemsettings.desktop',
    'org.kde.dolphin.desktop',
    'doublecmd-qt.desktop',
    'browser-selector.desktop',
    'libreoffice-startcenter.desktop',
    'libreoffice-writer.desktop',
    'blackPanther-popcorntime.desktop',
    'org.kde.kcalc.desktop',
    'org.kde.krusader.desktop',
].join(',')) 


var pager = panel.addWidget("org.kde.plasma.pager")
pager.currentConfigGroup = ["General"]
pager.writeConfig("showWindowIcons", "true")

var pager = panel.addWidget("org.kde.placesWidget")
pager.currentConfigGroup = ["General"]

var iconSystemSettings = panel.addWidget("org.kde.plasma.icon")
iconSystemSettings.writeConfig("url","file:///usr/share/applications/systemsettings.desktop");

var iconDolphin = panel.addWidget("org.kde.plasma.icon")
iconDolphin.writeConfig("url","file:///usr/share/applications/org.kde.kcalc.desktop");

var iconSystemSettings = panel.addWidget("org.kde.plasma.icon")
iconSystemSettings.writeConfig("url","file:///usr/share/applications/browser-selector.desktop");

//Spacer
//panel.addWidget("org.kde.plasma.panelspacer")

//panel.addWidget("org.kde.plasma.taskmanager")
var tasks = panel.addWidget("org.kde.plasma.taskmanager")
tasks.currentConfigGroup = ["Configuration","General"]
tasks.writeConfig("groupingStrategy", "0")
tasks.writeConfig("maxStripes", "1")
tasks.writeConfig("showOnlyCurrentActivity", "true")
tasks.writeConfig("showOnlyCurrentDesktop", "false")
tasks.writeConfig("sortingStrategy", "1")

/* Next up is determining whether to add the Input Method Panel
 * widget to the panel or not. This is done based on whether
 * the system locale's language id is a member of the following
 * white list of languages which are known to pull in one of
 * our supported IME backends when chosen during installation
 * of common distributions. */


var langIds = ["as",    // Assamese
               "bn",    // Bengali
               "bo",    // Tibetan
               "brx",   // Bodo
               "doi",   // Dogri
               "gu",    // Gujarati
               "hi",    // Hindi
               "ja",    // Japanese
               "kn",    // Kannada
               "ko",    // Korean
               "kok",   // Konkani
               "ks",    // Kashmiri
               "lep",   // Lepcha
               "mai",   // Maithili
               "ml",    // Malayalam
               "mni",   // Manipuri
               "mr",    // Marathi
               "ne",    // Nepali
               "or",    // Odia
               "pa",    // Punjabi
               "sa",    // Sanskrit
               "sat",   // Santali
               "sd",    // Sindhi
               "si",    // Sinhala
               "ta",    // Tamil
               "te",    // Telugu
               "th",    // Thai
               "ur",    // Urdu
               "vi",    // Vietnamese
               "zh_CN", // Simplified Chinese
               "zh_TW"] // Traditional Chinese

if (langIds.indexOf(languageId) != -1) {
    panel.addWidget("org.kde.plasma.kimpanel");
}

var systray = panel.addWidget("org.kde.plasma.systemtray")
systray.currentConfigGroup = ["General"]
systray.writeConfig("extraItems", [
    'org.kde.plasma.weather',
    'org.kde.plasma.notifications',
    'org.kde.plasma.networkmanagement',
    'org.kde.plasma.pkupdates',
    'org.kde.plasma.volume',
    'org.kde.plasma.mediacontroller',
].join(','))
systray.writeConfig("hiddenItems", [
    'org.kde.plasma.networkmanagement',
    'org.kde.redshiftControl',
    'org.kde.plasma.mediacontroller',
    'KTorrent',
].join(','))


panel.addWidget("org.kde.plasma.digitalclock")

var uswitcher = panel.addWidget("org.kde.plasma.uswitcher")
uswitcher.currentConfigGroup = ["Configuration", "General"]
uswitcher.writeConfig("showName", false)
uswitcher.writeConfig("showSett", true)

var plasma = getApiVersion(1);
var layout = {
    "desktops": [
        {
            "applets": [
            ],
            "config": {
                "/": {
                    "formfactor": "0",
                    "immutability": "1",
                    "lastScreen": "0",
                    "wallpaperplugin": "org.kde.image"
                },
                "/ConfigDialog": {
                    "DialogHeight": "600",
                    "DialogWidth": "800"
                },
                "/General": {
                    "alignment": "1",
                    "arrangement": "1",
                    "positions": "1,9,desktop:/trash.desktop,0,1,desktop:/Home.desktop,0,0",
                    "sortMode": "-1",
                    "showToolbox": "false"
                },

            },
            "wallpaperPlugin": "org.kde.image"
        }
    ],
    "panels": [
        {
            "alignment": "center",
            "applets": [
                {
                    "config": {
                        "/": {
                            "immutability": "1",
                            "pressureUnit": "5022",
                            "source": "bbcukmet|weather|Budapest / Ferihegy, Hungary|6299519",
                            "speedUnit": "9001",
                            "temperatureUnit": "6001",
                            "updateInterval": "30",
                            "visibilityUnit": "2007",
                            "weatherServiceProviders": "bbcukmet"
                        },
                        "/Configuration": {
                            "PreloadWeight": "65"
                        }
    
                    },
                    "plugin": "org.kde.plasma.weather"
                },
                {
                    "config": {
                        "/": {
                            "immutability": "1"
                        },
                        "/Shortcuts": {
                            "global": "Meta+F1"
                        }
                    },
                    "plugin": "org.kde.plasma.kickerdash"
                },
                {
                    "config": {
                        "/": {
                            "immutability": "1"
                        },
                        "/Configuration/General": {
                            "favoriteApps": "preferred://browser,systemsettings.desktop,org.kde.dolphin.desktop"
                        },
                    },
                    "plugin": "org.kde.plasma.quicklaunch"
                },
/*                {
                    "config": {
                        "/": {
                            "immutability": "1"
                        },
                        "/General": {
                            "sources": "cpu%2Fsystem%2FTotalLoad"
                        }
                    },
                    "plugin": "org.kde.plasma.systemmonitor.cpu"
                }, */
            ],
            "config": {
                "/": {
                    "formfactor": "3",
                    "immutability": "1",
                    "lastScreen": "0",
                    "wallpaperplugin": "org.kde.image"
                },
                "/ConfigDialog": {
                    "DialogHeight": "1080",
                    "DialogWidth": "178"
                }
            },
            "height": 3.5,
//            "hiding": "autohide",
            "location": "left",
            "maximumLength": 54,
            "minimumLength": 25.7,
            "offset": 0
        },

    ],
    "serializationFormatVersion": "1"
}
;

plasma.loadSerializedLayout(layout);
